GRPC Core 0.10.0.0

- Main Page
- Data Structures
- Files

- File List
- Globals

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Pages
Data Structures | Macros | Typedefs | Enumerations | Functions | Variables
jwt_verifier.h File Reference
`#include "src/core/iomgr/pollset.h"`
`#include "src/core/json/json.h"`
`#include <grpc/support/slice.h>`
`#include <grpc/support/time.h>`

Go to the source code of this file.

## Data Structures
struct | grpc_jwt_verifier_email_domain_key_url_mapping

## Macros
#define | GRPC_OPENID_CONFIG_URL_SUFFIX "/.well-known/openid-configuration"
#define | GRPC_GOOGLE_SERVICE_ACCOUNTS_EMAIL_DOMAIN "developer.gserviceaccount.com"
#define | GRPC_GOOGLE_SERVICE_ACCOUNTS_KEY_URL_PREFIX "www.googleapis.com/robot/v1/metadata/x509"

## Typedefs
typedef struct grpc_jwt_claims | grpc_jwt_claims
typedef struct grpc_jwt_verifier | grpc_jwt_verifier
typedef void(* | grpc_jwt_verification_done_cb )(void *user_data, grpc_jwt_verifier_status status, grpc_jwt_claims *claims)

## Enumerations
enum | grpc_jwt_verifier_status { GRPC_JWT_VERIFIER_OK = 0, GRPC_JWT_VERIFIER_BAD_SIGNATURE, GRPC_JWT_VERIFIER_BAD_FORMAT, GRPC_JWT_VERIFIER_BAD_AUDIENCE, GRPC_JWT_VERIFIER_KEY_RETRIEVAL_ERROR, GRPC_JWT_VERIFIER_TIME_CONSTRAINT_FAILURE, GRPC_JWT_VERIFIER_GENERIC_ERROR }

## Functions
const char * | grpc_jwt_verifier_status_to_string (grpc_jwt_verifier_status status)
void | grpc_jwt_claims_destroy (grpc_jwt_claims *claims)
const grpc_json * | grpc_jwt_claims_json (const grpc_jwt_claims *claims)
const char * | grpc_jwt_claims_subject (const grpc_jwt_claims *claims)
const char * | grpc_jwt_claims_issuer (const grpc_jwt_claims *claims)
const char * | grpc_jwt_claims_id (const grpc_jwt_claims *claims)
const char * | grpc_jwt_claims_audience (const grpc_jwt_claims *claims)
gpr_timespec | grpc_jwt_claims_issued_at (const grpc_jwt_claims *claims)
gpr_timespec | grpc_jwt_claims_expires_at (const grpc_jwt_claims *claims)
gpr_timespec | grpc_jwt_claims_not_before (const grpc_jwt_claims *claims)
grpc_jwt_verifier * | grpc_jwt_verifier_create (const grpc_jwt_verifier_email_domain_key_url_mapping *mappings, size_t num_mappings)
void | grpc_jwt_verifier_destroy (grpc_jwt_verifier *verifier)
void | grpc_jwt_verifier_verify (grpc_jwt_verifier *verifier, grpc_pollset *pollset, const char *jwt, const char *audience, grpc_jwt_verification_done_cb cb, void *user_data)
grpc_jwt_claims * | grpc_jwt_claims_from_json (grpc_json *json, gpr_slice buffer)
grpc_jwt_verifier_status | grpc_jwt_claims_check (const grpc_jwt_claims *claims, const char *audience)

## Variables
gpr_timespec | grpc_jwt_verifier_clock_skew
gpr_timespec | grpc_jwt_verifier_max_delay

## Macro Definition Documentation

#define GRPC_GOOGLE_SERVICE_ACCOUNTS_EMAIL_DOMAIN "developer.gserviceaccount.com"

#define GRPC_GOOGLE_SERVICE_ACCOUNTS_KEY_URL_PREFIX "www.googleapis.com/robot/v1/metadata/x509"

#define GRPC_OPENID_CONFIG_URL_SUFFIX "/.well-known/openid-configuration"

## Typedef Documentation

typedef struct grpc_jwt_claims grpc_jwt_claims

typedef void(* grpc_jwt_verification_done_cb)(void *user_data, grpc_jwt_verifier_status status, grpc_jwt_claims *claims)

typedef struct grpc_jwt_verifier grpc_jwt_verifier

## Enumeration Type Documentation

enum grpc_jwt_verifier_status

Enumerator
GRPC_JWT_VERIFIER_OK |
GRPC_JWT_VERIFIER_BAD_SIGNATURE |
GRPC_JWT_VERIFIER_BAD_FORMAT |
GRPC_JWT_VERIFIER_BAD_AUDIENCE |
GRPC_JWT_VERIFIER_KEY_RETRIEVAL_ERROR |
GRPC_JWT_VERIFIER_TIME_CONSTRAINT_FAILURE |
GRPC_JWT_VERIFIER_GENERIC_ERROR |

## Function Documentation

const char* grpc_jwt_claims_audience | ( | const grpc_jwt_claims * | claims | ) |

grpc_jwt_verifier_status grpc_jwt_claims_check | ( | const grpc_jwt_claims * | claims,
|  | const char * | audience
| ) |  |

void grpc_jwt_claims_destroy | ( | grpc_jwt_claims * | claims | ) |

gpr_timespec grpc_jwt_claims_expires_at | ( | const grpc_jwt_claims * | claims | ) |

grpc_jwt_claims* grpc_jwt_claims_from_json | ( | grpc_json * | json,
|  | gpr_slice | buffer
| ) |  |

const char* grpc_jwt_claims_id | ( | const grpc_jwt_claims * | claims | ) |

gpr_timespec grpc_jwt_claims_issued_at | ( | const grpc_jwt_claims * | claims | ) |

const char* grpc_jwt_claims_issuer | ( | const grpc_jwt_claims * | claims | ) |

const grpc_json* grpc_jwt_claims_json | ( | const grpc_jwt_claims * | claims | ) |

gpr_timespec grpc_jwt_claims_not_before | ( | const grpc_jwt_claims * | claims | ) |

const char* grpc_jwt_claims_subject | ( | const grpc_jwt_claims * | claims | ) |

grpc_jwt_verifier* grpc_jwt_verifier_create | ( | const grpc_jwt_verifier_email_domain_key_url_mapping * | mappings,
|  | size_t | num_mappings
| ) |  |

void grpc_jwt_verifier_destroy | ( | grpc_jwt_verifier * | verifier | ) |

const char* grpc_jwt_verifier_status_to_string | ( | grpc_jwt_verifier_status | status | ) |

void grpc_jwt_verifier_verify | ( | grpc_jwt_verifier * | verifier,
|  | grpc_pollset * | pollset,
|  | const char * | jwt,
|  | const char * | audience,
|  | grpc_jwt_verification_done_cb | cb,
|  | void * | user_data
| ) |  |

## Variable Documentation

gpr_timespec grpc_jwt_verifier_clock_skew

gpr_timespec grpc_jwt_verifier_max_delay